use potato_data::identifier::Identifier;
use potato_protocol_derive::{Packet, PacketEncodable};

use crate::datatypes::{position::Position, var_int::VarInt};

#[derive(Debug, Packet)]
#[packet(play_id = crate::ids::play::clientbound::LOGIN)]
pub struct LoginPacket {
    pub entity_id: i32,
    pub is_hardcore: bool,
    pub dimension_names: Vec<Identifier>,
    pub max_players: VarInt,
    pub view_distance: VarInt,
    pub simulation_distance: VarInt,
    pub reduced_debug_info: bool,
    pub enable_respawn_screen: bool,
    pub do_limited_crafting: bool,
    pub dimension_type: VarInt,
    pub dimension_name: Identifier,
    pub hashed_seed: i64,
    pub game_mode: u8,
    pub previous_game_mode: i8,
    pub is_debug: bool,
    pub is_flat: bool,
    pub death_info: Option<DeathInfo>,
    pub portal_cooldown: VarInt,
    pub sea_level: VarInt,
    pub enforces_secure_chat: bool,
}

#[derive(Debug, PacketEncodable)]
pub struct DeathInfo {
    pub death_dimension: Identifier,
    pub death_location: Position,
}
